package cn.com.qmth.examcloud.exchange.helper;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.commons.helpers.XStreamBuilder;
import cn.com.qmth.examcloud.commons.util.PathUtil;
import com.thoughtworks.xstream.XStream;
import org.apache.commons.lang3.StringUtils;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class XmlPropertyHelper {

    public static List<String> getIpWhiteListFormXml(Long rootOrgId) {
        String resoucePath = PathUtil.getResoucePath("ip-white-list.xml");
        if (resoucePath == null) {
            return new ArrayList<>();
        }

        XStream xStream = XStreamBuilder.newInstance().build();
        xStream.allowTypes(new Class[]{OrgInfo.class, List.class});
        xStream.alias("orgs", List.class);
        xStream.alias("org", OrgInfo.class);

        List<OrgInfo> list;
        try {
            File file = new File(resoucePath);
            list = (List<OrgInfo>) xStream.fromXML(file);
        } catch (Exception e) {
            throw new StatusException("500", "读取配置文件错误", e);
        }

        List<String> result = new ArrayList<>();
        for (OrgInfo cur : list) {
            if (cur.getRootOrgId().equals(rootOrgId)) {
                String values = cur.getIpWhitelist();
                if (values != null) {
                    String[] ips = values.trim().split(",");
                    for (String ip : ips) {
                        if (StringUtils.isNotEmpty(ip.trim())) {
                            result.add(ip.trim());
                        }
                    }
                    return result;
                }
                break;
            }
        }

        return result;
    }

}

